//+------------------------------------------------------------------+
//|                                                   TestRandom.mq4 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property strict
//---
#define MAX_SIZE 10000
//---
#define IM 139968
#define IA 3877
#define IC 29573
//+------------------------------------------------------------------+
//|  OnStart                                                  |
//+------------------------------------------------------------------+
int OnStart()
  {
   int  i,j,n=1;
   uint tick_count,res;
//--- 
   tick_count=GetTickCount();
   for(i=0;i<MAX_SIZE;i++)
      for(j=0;j<MAX_SIZE;j++)
         TestRandom(i+j);
   res=GetTickCount()-tick_count;
   Print("    ",res," .");
//---  ,    ,  
   return((int)res);
  }
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
double TestRandom(double max)
  {
   static long last=42;
//---
   last=(last*IA+IC)%IM;
   return(max*last/IM);
  }
//+------------------------------------------------------------------+
